diff -u Filezilla_OLD/source/LanguageDLLs/Polish/fz_polish.nsh Filezilla_NEW/source/LanguageDLLs/Polish/fz_polish.nsh
--- Filezilla_OLD/source/LanguageDLLs/Polish/fz_polish.nsh	2004-02-27 09:07:00.000000000 +0100
+++ Filezilla_NEW/source/LanguageDLLs/Polish/fz_polish.nsh	2005-05-05 11:38:52.000000000 +0200
@@ -31,7 +31,7 @@
 LangString SecFileZillaDesc ${CURLANG} "Instaluje FileZilla.exe oraz inne wymagane pliki"
 LangString SecDocumentationDesc ${CURLANG} "Kopiuje pliki dokumentacji do miejsca docelowego"
 LangString SecEnglishDocumentationDesc ${CURLANG} "Instaluj angielsk¹ dokumentacjê"
-LangString SecFrenchDocumentationDesc ${CURLANG} "Pobierz i instaluj Francusk¹ dokumentacjê"
+LangString SecFrenchDocumentationDesc ${CURLANG} "Pobierz i instaluj francusk¹ dokumentacjê"
 LangString SecLangFilesDesc ${CURLANG} "Kopiuje pliki jêzyka do miejsca docelowego"
 LangString SecSourceCodeDesc ${CURLANG} "Pobiera i kopiuje Ÿród³o kodu do miejsca docelowego."
 LangString SecStartMenuDesc ${CURLANG} "Tworzy klawisze skrótów w menu start"
@@ -48,7 +48,7 @@
 LangString QuestionRunInSecureMode ${CURLANG} "Czy chcesz uruchomiæ ${MUI_PRODUCT} w bezpiecznym trybie?\nW bezpiecznym trybie FileZilla nie pamiêta ¿adnych hase³.\nJest to zalecane je¿eli kilka osób ma dostêp do komputera."
 LangString UseSecureMode ${CURLANG} "U¿yj trybu ochrony"
 LangString DontUseSecureMode ${CURLANG} "Nie u¿ywaj trybu ochrony"
-LangString StorageQuestion ${CURLANG} "FileZilla mo¿e zapisaæ ustawienia w dwóch ró¿nych miejscach: W rejestrze i w pliku XML.\r\nW wiêkszoœci przypadków zaleca siê zapis do XML.\r\nJe¿eli pracujesz w trybie wielu u¿ytkowników, gdzie ka¿dy u¿ytkownik ma swój w³asny profil, to nale¿y u¿yæ zapisu do rejestru ¿eby ka¿dy u¿ytkownik mia³ swoje ustawienia dla FileZilla."
+LangString StorageQuestion ${CURLANG} "FileZilla mo¿e zapisaæ ustawienia w dwóch ró¿nych miejscach: W rejestrze i w pliku XML.\r\nW wiêkszoœci przypadków zaleca siê zapis do pliku XML.\r\nJe¿eli pracujesz w trybie wielu u¿ytkowników, gdzie ka¿dy u¿ytkownik ma swój w³asny profil, to nale¿y u¿yæ zapisu do rejestru, ¿eby ka¿dy u¿ytkownik mia³ swoje ustawienia dla FileZilla."
 LangString UseXML ${CURLANG} "U¿yj pliku &XML"
 LangString UseRegistry ${CURLANG} "U¿yj &rejestru"
 LangString ForceUseRegistry ${CURLANG} "Wymuœ zapis do rejestru nawet, gdy istnieje plik XML"
diff -u Filezilla_OLD/source/LanguageDLLs/Polish/FzResPo.rc Filezilla_NEW/source/LanguageDLLs/Polish/FzResPo.rc
--- Filezilla_OLD/source/LanguageDLLs/Polish/FzResPo.rc	2005-03-14 16:50:30.000000000 +0100
+++ Filezilla_NEW/source/LanguageDLLs/Polish/FzResPo.rc	2005-05-05 12:38:30.000000000 +0200
@@ -468,7 +468,7 @@
                     49,63,10
     CONTROL         "&HTTP 1.1 proxy",IDC_RADIO5,"Button",BS_AUTORADIOBUTTON,
                     7,60,66,10
-    GROUPBOX        "Szczegó³y Proxy",IDC_STATIC,7,73,283,100
+    GROUPBOX        "Szczegó³y proxy",IDC_STATIC,7,73,283,100
     LTEXT           "&Host:",IDC_STATIC,14,87,18,8
     EDITTEXT        IDC_PROXYHOST,56,83,178,14,ES_AUTOHSCROLL
     LTEXT           "&Port:",IDC_STATIC,14,105,16,8
@@ -491,21 +491,21 @@
     GROUPBOX        "Uprawnienia w³aœciciela",IDC_STATIC,7,27,192,25
     CONTROL         "Od&czyt",IDC_OWNERREAD,"Button",BS_AUTOCHECKBOX | 
                     WS_TABSTOP,19,38,39,10
-    CONTROL         "&Zapis",IDC_OWNERWRITE,"Button",BS_AUTOCHECKBOX | 
+    CONTROL         "&Zapis",IDC_OWNERWRITE,"Button",BS_AUTOCHECKBOX |
                     WS_TABSTOP,78,38,33,10
     CONTROL         "&Uruchamianie",IDC_OWNEREXECUTE,"Button",
                     BS_AUTOCHECKBOX | WS_TABSTOP,131,39,58,10
     GROUPBOX        "Uprawnienia grupy",IDC_STATIC,7,58,192,25
-    CONTROL         "Odczy&t",IDC_GROUPREAD,"Button",BS_AUTOCHECKBOX | 
+    CONTROL         "Odczy&t",IDC_GROUPREAD,"Button",BS_AUTOCHECKBOX |
                     WS_TABSTOP,19,69,41,10
-    CONTROL         "&Zap&is",IDC_GROUPWRITE,"Button",BS_AUTOCHECKBOX | 
+    CONTROL         "&Zap&is",IDC_GROUPWRITE,"Button",BS_AUTOCHECKBOX |
                     WS_TABSTOP,78,69,33,10
     CONTROL         "Urucha&mianie",IDC_GROUPEXECUTE,"Button",
                     BS_AUTOCHECKBOX | WS_TABSTOP,131,69,58,10
     GROUPBOX        "Uprawnienia publiczne",IDC_STATIC,7,89,192,25
-    CONTROL         "&Odczyt",IDC_PUBLICREAD,"Button",BS_AUTOCHECKBOX | 
+    CONTROL         "&Odczyt",IDC_PUBLICREAD,"Button",BS_AUTOCHECKBOX |
                     WS_TABSTOP,19,100,42,10
-    CONTROL         "Zapi&s",IDC_PUBLICWRITE,"Button",BS_AUTOCHECKBOX | 
+    CONTROL         "Zapi&s",IDC_PUBLICWRITE,"Button",BS_AUTOCHECKBOX |
                     WS_TABSTOP,78,100,33,10
     CONTROL         "Uruchamia&nie",IDC_PUBLICEXECUTE,"Button",
                     BS_AUTOCHECKBOX | WS_TABSTOP,131,100,58,10
@@ -547,7 +547,7 @@
                     34,10
     CONTROL         "&Binarny",IDC_TYPEMODE3,"Button",BS_AUTORADIOBUTTON,16,
                     40,35,10
-    LTEXT           "Powinno siê prze³¹czyæ te ustawienie na autodetekcjê. Wówczas program FileZilla wybierze najlepszy rodzaj transferu oparty na rozszerzeniu pliku. Ten transfer bêdzie u¿ywany przy ka¿dym starcie programu.",
+    LTEXT           "Powinno siê prze³¹czyæ to ustawienie na autodetekcjê. Wówczas program FileZilla wybierze najlepszy rodzaj transferu oparty na rozszerzeniu pliku. Ten transfer bêdzie u¿ywany przy ka¿dym starcie programu.",
                     IDC_STATIC,88,17,181,36
     GROUPBOX        "Pliki ASCII",IDC_STATIC,7,61,272,140,WS_GROUP
     LTEXT           "Je¿eli wybrano autodetekcjê to FileZilla u¿yje transferu ASCII dla nastêpuj¹cych rodzajów plików:",
@@ -572,7 +572,7 @@
     EDITTEXT        IDC_GSSSERVERNAME,129,66,49,14,ES_AUTOHSCROLL
     PUSHBUTTON      "&Dodaj",IDC_SERVERADD,129,84,50,14
     PUSHBUTTON      "&Usuñ",IDC_SERVERREMOVE,129,102,50,14
-    LTEXT           "Nale¿y mieæ zainstalowany modu³ Kerberos dla Windows (KfW). Je¿eli nie ma tego modu³u to funkcja ta nie bêdzie dzia³aæ. Z chwil¹ aktywowana tej funkcji program FileZilla u¿yje uwierzytelniania GSS i szyfrowania dla serwerów wymienionych w liœcie.",
+    LTEXT           "Nale¿y mieæ zainstalowany modu³ Kerberos dla Windows (KfW). Je¿eli nie ma tego modu³u to funkcja ta nie bêdzie dzia³aæ. Z chwil¹ aktywowania tej funkcji program FileZilla u¿yje uwierzytelniania GSS i szyfrowania dla serwerów wymienionych w liœcie.",
                     IDC_STATIC,7,21,286,31
     GROUPBOX        "Dostêpne serwery GSS",IDC_STATIC,7,55,286,149
     LTEXT           "Dla ka¿dego serwera, którego adres koñczy siê ci¹giem znaków zostanie u¿yty GSS. Proszê wpisywaæ tylko te serwery, które obs³uguj¹ GSS.",
@@ -956,7 +956,7 @@
 STYLE DS_SETFONT | DS_FIXEDSYS | DS_CONTROL | WS_CHILD
 FONT 8, "MS Shell Dlg", 0, 0, 0x1
 BEGIN
-    LTEXT           "Te ustawienia s¹ tylko potrzebne w procesie wykrywania b³êdów. Normalnie nie trzeba tych ustawieñ zmieniaæ. Jednak je¿eli napotkasz na jakieœ problemy w programie FileZila to mo¿esz uruchomiæ t¹ opcjê. Mo¿e ona byæ pomocna w rozwi¹zaniu problemów.",
+    LTEXT           "Te ustawienia s¹ tylko potrzebne w procesie wykrywania b³êdów. Normalnie nie trzeba tych ustawieñ zmieniaæ. Jednak je¿eli napotkasz na jakieœ problemy w programie FileZilla to mo¿esz uruchomiæ t¹ opcjê. Mo¿e ona byæ pomocna w rozwi¹zaniu problemów.",
                     IDC_STATIC,7,7,278,32
     CONTROL         "Monitoruj komunikaty serwera ftp",IDC_DEBUG_ENGINETRACE,
                     "Button",BS_AUTOCHECKBOX | WS_TABSTOP,7,43,129,10
@@ -1088,7 +1088,7 @@
     CONTROL         "Przechwyæ datê/czas pobranych plików",
                     IDC_OPTIONS_TRANSFER_PRESERVEDATETIME,"Button",
                     BS_AUTOCHECKBOX | WS_TABSTOP,7,7,231,10
-    LTEXT           "U¿yj podstawowego po³¹czenia dla transferu, gdy rozmiar pliku jest mniejszy od",
+    LTEXT           "U¿yj podstawowego po³¹czenia dla transferu, gdy rozmiar pliku jest mniejszy od:",
                     IDC_STATIC,7,20,256,8
     EDITTEXT        IDC_OPTIONS_TRANSFER_MAXPRIMARYSIZE,7,30,31,14,
                     ES_AUTOHSCROLL | ES_NUMBER
@@ -1153,8 +1153,8 @@
     CONTROL         "W³¹cz tylko podczas ³¹czenia siê",
                     IDC_OPTIONS_IDENT_IDENTCONNECT,"Button",BS_AUTOCHECKBOX | 
                     WS_TABSTOP,7,58,125,10
-    CONTROL         "Akceptyuj tylko zapytania z tego samego IP",
-                    IDC_OPTIONS_IDENT_SAMEIP,"Button",BS_AUTOCHECKBOX | 
+    CONTROL         "Akceptuj tylko zapytania z tego samego IP",
+                    IDC_OPTIONS_IDENT_SAMEIP,"Button",BS_AUTOCHECKBOX |
                     WS_TABSTOP,136,58,157,10
     LTEXT           "Niektóre serwery FTP wymagaj¹, aby podczas ³¹czenia siê z nimi by³a uruchomiona identyfikacja serwera.",
                     IDC_STATIC,7,7,236,17
@@ -1383,7 +1383,7 @@
 STYLE DS_SETFONT | DS_FIXEDSYS | DS_CONTROL | WS_CHILD
 FONT 8, "MS Shell Dlg"
 BEGIN
-    LTEXT           "U¿ywa MODE Z, rozszerzenia protokó³u ftp. Jest mo¿liwe u¿ycie skompresowanego transferu pliku, na serwerach, które to obs³uguj¹.",
+    LTEXT           "U¿ywa MODE Z, rozszerzenia protoko³u ftp. Jest mo¿liwe u¿ycie skompresowanego transferu pliku, na serwerach, które to obs³uguj¹.",
                     IDC_STATIC,7,7,272,18
     CONTROL         "Nie u¿ywaj kompresji",
                     IDC_OPTIONS_TRANSFER_COMPRESSION_USECOMPRESSION,"Button",
@@ -2082,7 +2082,7 @@
     IDS_ERRORMSG_CANTRESOLVEHOST "Nie mo¿na zanalizowaæ nazwy host "
     IDS_ERRORMSG_CANTRESUME "Komenda ponawiania nie jest obs³ugiwana przez serwer. Czy nadpisaæ plik?"
     IDS_ERRORMSG_CANTRESUME_FINISH 
-                            "Komenda ponawiania nie jest obs³ugiwana przez serwer ale rozmiar pliku lokalnego i na serwerze jest ten sam."
+                            "Komenda ponawiania nie jest obs³ugiwana przez serwer, ale rozmiar pliku lokalnego i na serwerze jest ten sam."
     IDS_ERRORMSG_CANTSENDCOMMAND "Nie mo¿na wys³aæ komendy! Serwer nieczynny!"
     IDS_ERRORMSG_CANTWRITETOFILE 
                             "Nie mo¿na zapisaæ do pliku ""%s"". B³¹d: ""%s"""
@@ -2133,7 +2133,7 @@
     IDS_ERRORMSG_SFTP_CLOSED 
                             "FzSFtp.exe zosta³ zamkniêty, przerwane po³¹czenie."
     IDS_ERRORMSG_SFTP_INVALIDDATA 
-                            "Zosta³y znalezione z³e dane w kanale danych SFtp, przerwa po³¹czenie."
+                            "Zosta³y znalezione z³e dane w kanale danych SFTP, przerywa po³¹czenie."
     IDS_ERRORMSG_SFTP_NORESPONSE 
                             "FzSFtp.exe nie odpowiedzia³, przerywa po³¹czenie."
     IDS_ERRORMSG_SITEMANAGERNAMEINUSE 
@@ -2169,7 +2169,7 @@
     IDS_ERRORMSG_CANTLOADSSLDLLS 
                             "Nie mo¿na wczytaæ bibliotek SSL. Proszê upewnij siê, ¿e pliki ""ssleay32.dll"" i ""libeay32.dll"" s¹ w tym samym folderze co  FileZilla."
     IDS_ERRORMSG_CANTOPENFILE "Nie mo¿na otworzyæ pliku wejœciowego!"
-    IDS_ERRORMSG_CANTOPENLOGFILE 
+    IDS_ERRORMSG_CANTOPENLOGFILE
                             "Plik raportu (log) ""%s"" nie zosta³ otwarty. Rejestrowanie do pliku zostanie wy³¹czone w tej sesji."
 END
 
@@ -2195,7 +2195,7 @@
     IDS_STATUSMSG_IDENT_START "Uruchomiono identyfikacjê serwera"
     IDS_STATUSMSG_IDENT_STOP "Zatrzymano identyfikacjê serwera"
     IDS_STATUSMSG_LANGUAGEVERSIONDIFFERENT 
-                            "Uwaga! Plik jêzykowy DLL zosta³ utworzony dla wczeœniejszej wersji programu FileZilla i nie jest zgodny z t¹ wersj¹. Proszê œci¹gni plik DLL dla nowszej wersji z!"
+                            "Uwaga! Plik jêzykowy DLL zosta³ utworzony dla wczeœniejszej wersji programu FileZilla i nie jest zgodny z t¹ wersj¹. Proszê œci¹gnij plik DLL dla nowszej wersji z!"
 END
 
 STRINGTABLE 
@@ -2224,10 +2224,10 @@
                             "Czy na pewno usun¹æ pliki i katalogi %d ?"
     IDS_QUESTION_FILEEXISTS "Plik ""%s"" (%d bajtów) ju¿ istnieje. Czy nadpisaæ plikiem ""%s"" (%d bajtów)?"
     IDS_QUESTION_OPTIONS_FIRSTSTART 
-                            "Uruchamiasz pierwszy raz t¹ wersjê FileZilla lub twoje ustawienia zosta³y usuniête.\nFileZilla mo¿e zapisaæ te ustawienia w rejestrze lub w pliku XML.\nCzy chcesz, aby FileZilla u¿ywa³ rejestru?\nJest to zalecane je¿eli jesteœ w otoczeniu wielu u¿ytkowników\nWybierz 'Nie', aby u¿ywaæ pliku XML, który jest zalecany dla wiêkszoœci u¿ytkowników.\nJe¿eli wybierzesz nie a  ustawienia znajduj¹ siê w rejestrze, to zostan¹ one zaimportowane do pliku XML."
-    IDS_QUESTION_SFTP_CHANGEDHOSTKEY 
-                            "UWAGA - POTENCJALNE NARUSZENIE BEZPIECZEÑSTWA!\nKlucz serwera host nie odpowiada poprzednio\nbuforowanemu (zapisanemu) w rejestrze. To oznacza, ¿e albo administrator\nserwera host zmieni³ klucz  lub jesteœ\naktualnie pod³¹czony(na) do innego komputera naœladuj¹cego\nserwer.\nNowy klucz identyfikacyjny serwera to:\n%s\nJe¿eli spodziewa³eœ(³aœ) siê tej zmiany i ufasz nowemu kluczowi,\nwybierz 'Tak', aby uaktualnic bufor ikontynuowaæ po³¹czenie.\nJe¿eli chcesz prowadziæ po³¹czenie bez uaktualniania\nbufora, wybierz 'Nie'.\nJe¿eli chcesz ca³kowicie pomin¹æ po³¹czenie, kliknij\n'Anuluj'. Tylko wybranie 'Anuluj' gwarantuje\nbezpieczny wybór.\nCzy uaktualniæ buforowany klucz?"
-    IDS_QUESTION_SFTP_NEWHOSTKEY 
+                            "Uruchamiasz pierwszy raz t¹ wersjê FileZilla lub twoje ustawienia zosta³y usuniête.\nFileZilla mo¿e zapisaæ te ustawienia w rejestrze lub w pliku XML.\nCzy chcesz, aby FileZilla u¿ywa³ rejestru?\nJest to zalecane je¿eli jesteœ w otoczeniu wielu u¿ytkowników\nWybierz 'Nie', aby u¿ywaæ pliku XML, który jest zalecany dla wiêkszoœci u¿ytkowników.\nJe¿eli wybierzesz 'Nie', a ustawienia znajduj¹ siê w rejestrze, to zostan¹ one zaimportowane do pliku XML."
+    IDS_QUESTION_SFTP_CHANGEDHOSTKEY
+                            "UWAGA - POTENCJALNE NARUSZENIE BEZPIECZEÑSTWA!\nKlucz serwera host nie odpowiada poprzednio\nbuforowanemu (zapisanemu) w rejestrze. To oznacza, ¿e albo administrator\nserwera host zmieni³ klucz lub jesteœ\naktualnie pod³¹czony(na) do innego komputera naœladuj¹cego\nserwer.\nNowy klucz identyfikacyjny serwera to:\n%s\nJe¿eli spodziewa³eœ(³aœ) siê tej zmiany i ufasz nowemu kluczowi,\nwybierz 'Tak', aby uaktualniæ bufor i kontynuowaæ po³¹czenie.\nJe¿eli chcesz prowadziæ po³¹czenie bez uaktualniania\nbufora, wybierz 'Nie'.\nJe¿eli chcesz ca³kowicie pomin¹æ po³¹czenie, kliknij\n'Anuluj'. Tylko wybranie 'Anuluj' gwarantuje\nbezpieczny wybór.\nCzy uaktualniæ buforowany klucz?"
+    IDS_QUESTION_SFTP_NEWHOSTKEY
                             "Klucz serwera host nie jest buforowany w rejestrze. Nie\nmasz gwarancji, ¿e ten serwer to komputer, o którym\nmyœlisz.\nKlucz identyfikacyjny serwera to:\n%s\nJe¿eli ufasz temu komputerowi, wybierz 'Tak', aby dodaæ klucz do\\bufora i prowadziæ po³¹czenie.\nJe¿eli chcesz przeprowadziæ pod³¹czenie tylko raz, bez\ndodawania klucza do bufora, wybierz 'Nie'.\nJe¿eli nie ufasz temu komputerowi, wybierz 'Anuluj', aby zaprzestaæ\npo³¹czenia.\nCzy zapisaæ klucz w buforze?"
     IDS_QUESTION_SITEMANAGERDELETE "Czy na pewno usun¹æ ""%s""?"
     IDS_QUESTION_VIEWEDIT_MODIFIED 
@@ -2267,7 +2267,7 @@
 
 STRINGTABLE 
 BEGIN
-    IDS_GSSERROR_AUTHFAILED "Uwierzytelnianie zakoñczy³o siê niepowidzeniem, czêsto oznacza to, ¿e\nnie masz Kerberos v.5.\nRozwa¿ uruchomienie Leash32.\nCzy chcesz wys³aæ wsztystkie dane bez szyfrowania,\ni potencjalnie ujawniæ swoje has³o?"
+    IDS_GSSERROR_AUTHFAILED "Uwierzytelnianie zakoñczy³o siê niepowodzeniem, czêsto oznacza to, ¿e\nnie masz Kerberos v.5.\nRozwa¿ uruchomienie Leash32.\nCzy chcesz wys³aæ wsztystkie dane bez szyfrowania,\ni potencjalnie ujawniæ swoje has³o?"
     IDS_GSSERROR_CANTLOADDLL "Nie mo¿na znaleŸæ lub wczytaæ %s"
     IDS_GSSERROR_CANTLOADGSSAPI 
                             "Jeden lub wiêcej GSS-API's nie zosta³(y) za³adowany(ne)!"
Wspólne podkatalogi: Filezilla_OLD/source/LanguageDLLs/Polish/Res i Filezilla_NEW/source/LanguageDLLs/Polish/Res

 	  	 