Index: src/interface/optionspage_connection.cpp
===================================================================
--- src/interface/optionspage_connection.cpp	(Revision 2117)
+++ src/interface/optionspage_connection.cpp	(Arbeitskopie)
@@ -12,29 +12,16 @@
 bool COptionsPageConnection::LoadPage()
 {
 	bool failure = false;
-	SetRCheck(XRCID("ID_PASSIVE"), m_pOptions->GetOptionVal(OPTION_USEPASV) != 0, failure);
-	SetRCheck(XRCID("ID_ACTIVE"), m_pOptions->GetOptionVal(OPTION_USEPASV) == 0, failure);
-	SetCheck(XRCID("ID_FALLBACK"), m_pOptions->GetOptionVal(OPTION_ALLOW_TRANSFERMODEFALLBACK) != 0, failure);
-
 	SetTextFromOption(XRCID("ID_RETRIES"), OPTION_RECONNECTCOUNT, failure);
 	SetTextFromOption(XRCID("ID_RETRYDELAY"), OPTION_RECONNECTDELAY, failure);
-
-	SetCheck(XRCID("ID_USEKEEPALIVE"), m_pOptions->GetOptionVal(OPTION_FTP_SENDKEEPALIVE) != 0, failure);
-
 	return !failure;
 }
 
 bool COptionsPageConnection::SavePage()
 {
-	m_pOptions->SetOption(OPTION_USEPASV, GetRCheck(XRCID("ID_PASSIVE")) ? 1 : 0);
-	m_pOptions->SetOption(OPTION_ALLOW_TRANSFERMODEFALLBACK, GetCheck(XRCID("ID_FALLBACK")) ? 1 : 0);
-
 	long tmp;
 	GetText(XRCID("ID_RETRIES")).ToLong(&tmp); m_pOptions->SetOption(OPTION_RECONNECTCOUNT, tmp);
 	GetText(XRCID("ID_RETRYDELAY")).ToLong(&tmp); m_pOptions->SetOption(OPTION_RECONNECTDELAY, tmp);
-
-	m_pOptions->SetOption(OPTION_FTP_SENDKEEPALIVE, GetCheck(XRCID("ID_USEKEEPALIVE")) ? 1 : 0);
-
 	return true;
 }
 
Index: src/interface/settingsdialog.cpp
===================================================================
--- src/interface/settingsdialog.cpp	(Revision 2117)
+++ src/interface/settingsdialog.cpp	(Arbeitskopie)
@@ -3,6 +3,7 @@
 #include "Options.h"
 #include "optionspage.h"
 #include "optionspage_connection.h"
+#include "optionspage_connection_ftp.h"
 #include "optionspage_connection_active.h"
 #include "optionspage_connection_passive.h"
 #include "optionspage_filetype.h"
@@ -25,6 +26,7 @@
 {
 	page_none = -1,
 	page_connection = 0,
+	page_connection_ftp,
 	page_connection_active,
 	page_connection_passive,
 	page_connection_ftp_proxy,
@@ -104,9 +106,10 @@
 	// Create the instances of the page classes and fill the tree.
 	t_page page;
 	ADD_PAGE(_("Connection"), COptionsPageConnection, page_none);
-	ADD_PAGE(_("Active mode"), COptionsPageConnectionActive, page_connection);
-	ADD_PAGE(_("Passive mode"), COptionsPageConnectionPassive, page_connection);
-	ADD_PAGE(_("FTP Proxy"), COptionsPageFtpProxy, page_connection);
+	ADD_PAGE(_("FTP"), COptionsPageConnectionFTP, page_connection);
+	ADD_PAGE(_("Active mode"), COptionsPageConnectionActive, page_connection_ftp);
+	ADD_PAGE(_("Passive mode"), COptionsPageConnectionPassive, page_connection_ftp);
+	ADD_PAGE(_("FTP Proxy"), COptionsPageFtpProxy, page_connection_ftp);
 	ADD_PAGE(_("Transfers"), COptionsPageTransfer, page_none);
 	ADD_PAGE(_("File Types"), COptionsPageFiletype, page_transfer);
 	ADD_PAGE(_("File exists action"), COptionsPageFileExists, page_transfer);
Index: src/interface/Makefile.am
===================================================================
--- src/interface/Makefile.am	(Revision 2117)
+++ src/interface/Makefile.am	(Arbeitskopie)
@@ -43,6 +43,7 @@
 		Options.cpp \
 		optionspage.cpp \
 		optionspage_connection.cpp \
+		optionspage_connection_ftp.cpp \
 		optionspage_connection_active.cpp \
 		optionspage_connection_passive.cpp \
 		optionspage_dateformatting.cpp \
@@ -122,6 +123,7 @@
 		 Options.h \
 		 optionspage.h \
 		 optionspage_connection.h \
+		 optionspage_connection_ftp.h \
 		 optionspage_connection_active.h \
 		 optionspage_connection_passive.h \
 		 optionspage_dateformatting.h \
Index: src/interface/resources/dialogs.xrc
===================================================================
--- src/interface/resources/dialogs.xrc	(Revision 2117)
+++ src/interface/resources/dialogs.xrc	(Arbeitskopie)
@@ -1,42 +1,6 @@
 <?xml version="1.0" encoding="ISO-8859-1"?>
 <resource version="2.3.0.1" xmlns="http://www.wxwindows.org/wxxrc">
-  <object class="wxPanel" name="ID_SETTINGS_CONNECTION_PASSIVE">
-    <object class="wxBoxSizer">
-      <orient>wxVERTICAL</orient>
-      <object class="sizeritem">
-        <object class="wxStaticBoxSizer">
-          <label>Passive mode</label>
-          <orient>wxVERTICAL</orient>
-          <object class="sizeritem">
-            <object class="wxFlexGridSizer">
-              <object class="sizeritem">
-                <object class="wxStaticText">
-                  <label>Some misconfigured remote servers which are behind a router, may reply with their local IP address.</label>
-                </object>
-              </object>
-              <object class="sizeritem">
-                <object class="wxRadioButton" name="ID_PASSIVE_FALLBACK1">
-                  <label>&amp;Use the server's external IP address instead</label>
-                  <style>wxRB_GROUP</style>
-                </object>
-              </object>
-              <object class="sizeritem">
-                <object class="wxRadioButton" name="ID_PASSIVE_FALLBACK2">
-                  <label>&amp;Fall back to active mode</label>
-                </object>
-              </object>
-              <cols>1</cols>
-              <vgap>3</vgap>
-              <rows>2</rows>
-            </object>
-            <flag>wxLEFT|wxRIGHT|wxBOTTOM</flag>
-            <border>4</border>
-          </object>
-        </object>
-        <flag>wxGROW</flag>
-      </object>
-    </object>
-  </object>
+  
   <object class="wxDialog" name="ID_VERIFYCERT">
     <title>Unknown certificate</title>
     <object class="wxBoxSizer">
@@ -46,7 +10,7 @@
           <orient>wxHORIZONTAL</orient>
           <object class="sizeritem">
             <object class="wxStaticBitmap" name="ID_IMAGE">
-              <bitmap stock_id="wxART_INFORMATION"></bitmap>
+              <bitmap stock_id="wxART_INFORMATION"/>
             </object>
             <flag>wxALL</flag>
             <border>7</border>
@@ -82,7 +46,7 @@
                       </object>
                       <object class="sizeritem">
                         <object class="wxStaticText" name="ID_ACTIVATION_TIME">
-                          <label></label>
+                          <label/>
                         </object>
                       </object>
                       <object class="sizeritem">
@@ -92,7 +56,7 @@
                       </object>
                       <object class="sizeritem">
                         <object class="wxStaticText" name="ID_EXPIRATION_TIME">
-                          <label></label>
+                          <label/>
                         </object>
                       </object>
                       <object class="sizeritem">
@@ -102,7 +66,7 @@
                       </object>
                       <object class="sizeritem">
                         <object class="wxStaticText" name="ID_SERIAL">
-                          <label></label>
+                          <label/>
                         </object>
                       </object>
                       <object class="sizeritem">
@@ -112,7 +76,7 @@
                       </object>
                       <object class="sizeritem">
                         <object class="wxStaticText" name="ID_PKALGO">
-                          <label></label>
+                          <label/>
                         </object>
                       </object>
                       <object class="sizeritem">
@@ -122,7 +86,7 @@
                       </object>
                       <object class="sizeritem">
                         <object class="wxStaticText" name="ID_FINGERPRINT_MD5">
-                          <label></label>
+                          <label/>
                         </object>
                       </object>
                       <object class="sizeritem">
@@ -132,7 +96,7 @@
                       </object>
                       <object class="sizeritem">
                         <object class="wxStaticText" name="ID_FINGERPRINT_SHA1">
-                          <label></label>
+                          <label/>
                         </object>
                       </object>
                       <vgap>3</vgap>
@@ -236,6 +200,43 @@
       </object>
     </object>
   </object>
+  <object class="wxPanel" name="ID_SETTINGS_CONNECTION_PASSIVE">
+    <object class="wxBoxSizer">
+      <orient>wxVERTICAL</orient>
+      <object class="sizeritem">
+        <object class="wxStaticBoxSizer">
+          <label>Passive mode</label>
+          <orient>wxVERTICAL</orient>
+          <object class="sizeritem">
+            <object class="wxFlexGridSizer">
+              <object class="sizeritem">
+                <object class="wxStaticText">
+                  <label>Some misconfigured remote servers which are behind a router, may reply with their local IP address.</label>
+                </object>
+              </object>
+              <object class="sizeritem">
+                <object class="wxRadioButton" name="ID_PASSIVE_FALLBACK1">
+                  <label>&amp;Use the server's external IP address instead</label>
+                  <style>wxRB_GROUP</style>
+                </object>
+              </object>
+              <object class="sizeritem">
+                <object class="wxRadioButton" name="ID_PASSIVE_FALLBACK2">
+                  <label>&amp;Fall back to active mode</label>
+                </object>
+              </object>
+              <cols>1</cols>
+              <vgap>3</vgap>
+              <rows>2</rows>
+            </object>
+            <flag>wxLEFT|wxRIGHT|wxBOTTOM</flag>
+            <border>4</border>
+          </object>
+        </object>
+        <flag>wxGROW</flag>
+      </object>
+    </object>
+  </object>
   <object class="wxPanel" name="ID_SETTINGS_TRANSFER">
     <object class="wxBoxSizer">
       <orient>wxVERTICAL</orient>
@@ -412,7 +413,7 @@
               </object>
               <object class="sizeritem">
                 <object class="wxStaticText">
-                  <label></label>
+                  <label/>
                 </object>
               </object>
               <cols>3</cols>
@@ -770,7 +771,7 @@
                                 <object class="sizeritem">
                                   <object class="wxTextCtrl" name="ID_PORT">
                                     <size>50,-1</size>
-                                    <style></style>
+                                    <style/>
                                   </object>
                                   <flag>wxLEFT</flag>
                                   <border>5</border>
@@ -1177,7 +1178,7 @@
             <object class="wxButton" name="ID_CONNECT">
               <label>&amp;Connect</label>
               <default>1</default>
-              <style></style>
+              <style/>
             </object>
             <flag>wxALL|wxGROW</flag>
             <border>5</border>
@@ -1185,7 +1186,7 @@
           <object class="sizeritem">
             <object class="wxButton" name="wxID_OK">
               <label>&amp;OK</label>
-              <style></style>
+              <style/>
             </object>
             <flag>wxALL|wxGROW</flag>
             <border>5</border>
@@ -1226,7 +1227,7 @@
           </object>
           <object class="sizeritem">
             <object class="wxStaticText" name="ID_NAME">
-              <label></label>
+              <label/>
             </object>
           </object>
           <object class="sizeritem">
@@ -1236,7 +1237,7 @@
           </object>
           <object class="sizeritem">
             <object class="wxStaticText" name="ID_HOST">
-              <label></label>
+              <label/>
             </object>
           </object>
           <object class="sizeritem">
@@ -1246,7 +1247,7 @@
           </object>
           <object class="sizeritem">
             <object class="wxStaticText" name="ID_USER">
-              <label></label>
+              <label/>
             </object>
           </object>
           <vgap>5</vgap>
@@ -1635,44 +1636,9 @@
         </object>
         <flag>wxGROW</flag>
       </object>
+      
       <object class="sizeritem">
         <object class="wxStaticBoxSizer">
-          <label>Transfer Mode</label>
-          <orient>wxVERTICAL</orient>
-          <object class="sizeritem">
-            <object class="wxFlexGridSizer">
-              <object class="sizeritem">
-                <object class="wxRadioButton" name="ID_PASSIVE">
-                  <label>Pa&amp;ssive (recommended)</label>
-                  <style>wxRB_GROUP</style>
-                </object>
-              </object>
-              <object class="sizeritem">
-                <object class="wxRadioButton" name="ID_ACTIVE">
-                  <label>&amp;Active</label>
-                </object>
-              </object>
-              <object class="sizeritem">
-                <object class="wxCheckBox" name="ID_FALLBACK">
-                  <label>Allow fall back to other transfer mode on failure</label>
-                </object>
-              </object>
-              <object class="sizeritem">
-                <object class="wxStaticText">
-                  <label>If you have problems to retrieve directory listings or to transfer files, try to change the default transfer mode.</label>
-                </object>
-              </object>
-              <cols>1</cols>
-              <vgap>5</vgap>
-            </object>
-            <flag>wxBOTTOM|wxLEFT|wxRIGHT</flag>
-            <border>4</border>
-          </object>
-        </object>
-        <flag>wxGROW</flag>
-      </object>
-      <object class="sizeritem">
-        <object class="wxStaticBoxSizer">
           <label>Reconnection settings</label>
           <orient>wxVERTICAL</orient>
           <object class="sizeritem">
@@ -1730,33 +1696,7 @@
         </object>
         <flag>wxGROW</flag>
       </object>
-      <object class="sizeritem">
-        <object class="wxStaticBoxSizer">
-          <label>FTP Keep-alive</label>
-          <orient>wxVERTICAL</orient>
-          <object class="sizeritem">
-            <object class="wxGridSizer">
-              <cols>1</cols>
-              <vgap>5</vgap>
-              <object class="sizeritem">
-                <object class="wxCheckBox" name="ID_USEKEEPALIVE">
-                  <label>Send FTP keep-alive commands</label>
-                </object>
-              </object>
-              <object class="sizeritem">
-                <object class="wxStaticText" name="">
-                  <label>A proper server does not require this. Contact the server administrator if you need this.</label>
-                </object>
-                <flag>wxALIGN_TOP</flag>
-              </object>
-            </object>
-            <flag>wxALL</flag>
-            <border>4</border>
-          </object>
-        </object>
-        <option>1</option>
-        <flag>wxGROW</flag>
-      </object>
+    
     </object>
   </object>
   <object class="wxPanel" name="ID_SETTINGS_THEMES">
@@ -2458,7 +2398,7 @@
     </object>
   </object>
   <object class="wxDialog" name="ID_INPUTDIALOG">
-    <title></title>
+    <title/>
     <object class="wxBoxSizer">
       <orient>wxVERTICAL</orient>
       <object class="sizeritem">
@@ -2711,7 +2651,7 @@
               <orient>wxVERTICAL</orient>
               <object class="sizeritem">
                 <object class="wxStaticBitmap">
-                  <bitmap stock_id="ART_FILEZILLA"></bitmap>
+                  <bitmap stock_id="ART_FILEZILLA"/>
                   <size>48,48</size>
                 </object>
                 <flag>wxALL</flag>
@@ -2774,7 +2714,7 @@
               </object>
               <object class="sizeritem">
                 <object class="wxStaticText" name="ID_HOST">
-                  <label></label>
+                  <label/>
                 </object>
               </object>
               <object class="sizeritem">
@@ -2784,7 +2724,7 @@
               </object>
               <object class="sizeritem">
                 <object class="wxStaticText" name="ID_BUILD">
-                  <label></label>
+                  <label/>
                 </object>
               </object>
               <object class="sizeritem">
@@ -2794,7 +2734,7 @@
               </object>
               <object class="sizeritem">
                 <object class="wxStaticText" name="ID_BUILDDATE">
-                  <label></label>
+                  <label/>
                 </object>
               </object>
               <object class="sizeritem">
@@ -2804,7 +2744,7 @@
               </object>
               <object class="sizeritem">
                 <object class="wxStaticText" name="ID_COMPILEDWITH">
-                  <label></label>
+                  <label/>
                 </object>
               </object>
               <object class="sizeritem">
@@ -2814,7 +2754,7 @@
               </object>
               <object class="sizeritem">
                 <object class="wxStaticText" name="ID_CFLAGS">
-                  <label></label>
+                  <label/>
                 </object>
               </object>
               <vgap>3</vgap>
@@ -2846,7 +2786,7 @@
           <orient>wxHORIZONTAL</orient>
           <object class="sizeritem">
             <object class="wxStaticBitmap">
-              <bitmap stock_id="wxART_INFORMATION"></bitmap>
+              <bitmap stock_id="wxART_INFORMATION"/>
             </object>
             <flag>wxALL</flag>
             <border>7</border>
@@ -2948,7 +2888,7 @@
           <orient>wxHORIZONTAL</orient>
           <object class="sizeritem">
             <object class="wxStaticBitmap">
-              <bitmap stock_id="wxART_WARNING"></bitmap>
+              <bitmap stock_id="wxART_WARNING"/>
             </object>
             <flag>wxALL</flag>
             <border>7</border>
@@ -3883,7 +3823,7 @@
         <border>5</border>
       </object>
     </object>
-    <style></style>
+    <style/>
   </object>
   <object class="wxPanel" name="ID_DEFAULTFILEEXISTS">
     <object class="wxBoxSizer">
@@ -4361,4 +4301,74 @@
       </object>
     </object>
   </object>
-</resource>
+  <object class="wxPanel" name="ID_SETTINGS_CONNECTION_FTP">
+    <object class="wxBoxSizer">
+      <orient>wxVERTICAL</orient>
+      
+      <object class="sizeritem">
+        <object class="wxStaticBoxSizer">
+          <label>Transfer Mode</label>
+          <orient>wxVERTICAL</orient>
+          <object class="sizeritem">
+            <object class="wxFlexGridSizer">
+              <object class="sizeritem">
+                <object class="wxRadioButton" name="ID_PASSIVE">
+                  <label>Pa&amp;ssive (recommended)</label>
+                  <style>wxRB_GROUP</style>
+                </object>
+              </object>
+              <object class="sizeritem">
+                <object class="wxRadioButton" name="ID_ACTIVE">
+                  <label>&amp;Active</label>
+                </object>
+              </object>
+              <object class="sizeritem">
+                <object class="wxCheckBox" name="ID_FALLBACK">
+                  <label>Allow fall back to other transfer mode on failure</label>
+                </object>
+              </object>
+              <object class="sizeritem">
+                <object class="wxStaticText">
+                  <label>If you have problems to retrieve directory listings or to transfer files, try to change the default transfer mode.</label>
+                </object>
+              </object>
+              <cols>1</cols>
+              <vgap>5</vgap>
+            </object>
+            <flag>wxBOTTOM|wxLEFT|wxRIGHT</flag>
+            <border>4</border>
+          </object>
+        </object>
+        <flag>wxGROW</flag>
+      </object>
+      
+      <object class="sizeritem">
+        <object class="wxStaticBoxSizer">
+          <label>FTP Keep-alive</label>
+          <orient>wxVERTICAL</orient>
+          <object class="sizeritem">
+            <object class="wxGridSizer">
+              <cols>1</cols>
+              <vgap>5</vgap>
+              <object class="sizeritem">
+                <object class="wxCheckBox" name="ID_USEKEEPALIVE">
+                  <label>Send FTP keep-alive commands</label>
+                </object>
+              </object>
+              <object class="sizeritem">
+                <object class="wxStaticText" name="">
+                  <label>A proper server does not require this. Contact the server administrator if you need this.</label>
+                </object>
+                <flag>wxALIGN_TOP</flag>
+              </object>
+            </object>
+            <flag>wxALL</flag>
+            <border>4</border>
+          </object>
+        </object>
+        <option>1</option>
+        <flag>wxGROW</flag>
+      </object>
+    </object>
+  </object>
+</resource>
\ Kein Zeilenvorschub am Ende der Datei

 	  	 